jQuery(document).ready(function($) { /*id="script.js"*/
	// Set object vars
	var screenMode, deviceType;
	var $_body = $("body"),
		$_stickyMenu = $(".side-menu-container"),
		$_scrollContent = $("#scrolling-content");
	var offset = 140;
	setTimeout(function() {
		if (deviceType == "mobile") {
			offset = 100;
		}
		if (deviceType == "largeScreen") {
			offset = 140;
		}
	}, 100);
	// Manipulate DOM

	// HIDE ALTERNATE LANGUAGE OPTIONS IN HEADER AND NAV
	$_body.addClass("no-languages");

	$("main")
		.find("h1")
		.attr("tabindex", 0)
		.attr("id", "bcgov-main-content");
	if ($("body.downloads").length || $("body.speech").length) {
		$("article").each(function() {
			$(this)
				.find("h2")
				.attr("tabindex", "0");
			$(this)
				.find("h3")
				.attr("tabindex", "0");
			$(this)
				.find("h4")
				.attr("tabindex", "0");
		});
	}

	// Handle events
	if ($("body.downloads").length || $("body.speech").length) {
		$("a.navbar-brand").on("click", function(e) {
			console.log("clicked");
			e.preventDefault();
			$(this)
				.closest(".navbar")
				.find(".navbar-toggler")
				.trigger("click");
		});
	}

	// Handle External links
	$(document).on("click", ".external", function() {
		doExternalClick(this);
	});

	// MANAGE EVENTS AFTER LOAD
	$(window).on("load", function() {
		// POST-LOAD ANIMATIONS
		if (screenMode == "landscape") {
		}
		if (screenMode == "portrait" || deviceType == "mobile") {
		}
		if (deviceType == "mobile") {
		}
		$(".dropdown-toggle").dropdown();
		var currentPage = String($("body").attr("class"));
		setTimeout(function() {
			$(".dropdown-item").each(function() {
				if (
					currentPage.toLowerCase().indexOf($(this).attr("id")) >= 0
				) {
					$(this).addClass("active");
				} else {
					$(this).removeClass("active");
				}
			});
			// Manipulate DOM
			if ($("body").hasClass("downloads")) {
				$(".ContentBox").remove();
			}
			$("a[href='#wp-top-navbar']").on("click", function(e) {
				e.stopPropagation();
				e.preventDefault();
				setTimeout(function() {
					$("#hamburger").click();
				}, 5);
			});
			$(".dropdown-item").on("focus", function(e) {
				if ($(".dropdown").hasClass("show")) {
					return;
				} else {
					console.log("no show");
					$("#hamburger").trigger("click");
				}
			});
			$("a[href='#bcgov-main-content']").on("click", function(e) {
				e.stopPropagation();
				e.preventDefault();
				$("#bcgov-main-content").focus();
			});
			$("#bcgov-main-content").on("focus", function() {
				console.log($("body").offset().top);
				$("html, body").animate(
					{
						scrollTop: $("main").offset().top - 160
					},
					300
				);
			});
		}, 50);
		// get hash if on Budget Materials page
		if ($("body.downloads").length) {
			if (deviceType == "mobile") {
				offset = 100;
			}
			if (deviceType == "largeScreen") {
				offset = 140;
			}
			var pageHash = window.location.hash;
			setTimeout(function() {
				if (pageHash == "#gotoAllMaterials") {
					inpageLink("#AllMaterials", offset);
				} else if (pageHash == "#gotoBudgetHighlights") {
					inpageLink("#BudgetHighlights", offset);
				} else if (pageHash == "#gotoStrategicPlan") {
					inpageLink("#StrategicPlan", offset);
				} else if (pageHash == "#gotoBudgetSpeech") {
					inpageLink("#BudgetSpeech", offset);
				} else if (pageHash == "#gotoMediaPresentation") {
					inpageLink("#MediaPresentation", offset);
				} else if (pageHash == "#gotoNewsReleases") {
					inpageLink("#NewsReleases", offset);
				}
			}, 150);
		}
		if ($_stickyMenu.length) {
			if ($_body.hasClass("largeScreen")) {
				var waypointOffset = offset;
				var sticky = new Waypoint.Sticky({
					element: $_stickyMenu[0],
					offset: waypointOffset
				});
				if ($("#clear-menu-highlighting").length) {
					var clearSticky = new Waypoint({
						element: $("#clear-menu-highlighting"),
						handler: function() {
							unsetBoldLink();
						},
						offset: waypointOffset
					});
				}
			}
			$_stickyMenu
				.css({
					width: $(".sticky-wrapper").width(),
					minWidth: $(".sticky-wrapper").width(),
					maxWidth: $(".sticky-wrapper").width()
				})
				.css({ opacity: 1 });
		}
	});

	$(window)
		.resize(function() {
			var height = $(window).height();
			var width = $(window).width();
			if (width > height) {
				// Landscape
				$_body.removeClass("portrait");
				$_body.addClass("landscape");
				screenMode = "landscape";
			} else {
				// Portrait
				$_body.removeClass("landscape");
				$_body.addClass("portrait");
				screenMode = "portrait";
			}
			if (width < 768) {
				// mobile
				$_body.removeClass("largeScreen");
				$_body.addClass("mobile");
				deviceType = "mobile";
			} else {
				$_body.removeClass("mobile");
				$_body.addClass("largeScreen");
				deviceType = "largeScreen";
			}
			// In-page Navigation Scrolling using the Budget Materials side menu'
			// automate side menu scroll
			if ($_stickyMenu.length) {
				var stickyWaypoint = [];
				var waypointOffset = offset;
				$(".menu-item")
					.find(".nav-link")
					.unbind("click.menuLinkEvent");
				$(".menu-item").each(function(i) {
					var $_self = $(this);
					if (i == 0) {
						$_self.find("a").addClass("first");
					}
					$(this)
						.find(".nav-link")
						.on("click.menuLinkEvent", function(e) {
							e.preventDefault();
							e.stopPropagation();
							inpageLink($(this).attr("href"), offset);
						});
					if ($_body.hasClass("largeScreen")) {
						setTimeout(function() {
							stickyWaypoint[i] = new Waypoint({
								element: $(
									"article" + $_self.find("a").attr("href")
								),
								handler: function() {
									unsetBoldLink();
									setBoldLink(
										$(
											"a[href='" +
												$_self.find("a").attr("href") +
												"']"
										)
									);
									// unsetOverrideSticky();
								},
								offset: waypointOffset
							});
						}, 50);
					}
				});

				$_stickyMenu.css({
					width: $(".sticky-wrapper").width(),
					minWidth: $(".sticky-wrapper").width(),
					maxWidth: $(".sticky-wrapper").width()
				});
			}
		})
		.resize();

	if ($_stickyMenu) {
		$(window).on("scroll resize load", getVisibleScrollContent);
	}

	// ADDED FUNCTIONS
	// Scroller menu helper functions
	function inpageLink(targetID, offset) {
		var currentPosition = $(window).scrollTop();
		$("html, body").animate(
			{
				scrollTop: Math.floor($(targetID).offset().top - offset),
				start: function() {
					$(window).scrollTop(currentPosition);
				}
			},
			300
		);
		setTimeout(function() {
			// Duplicate animate to offset scroll up jump that occurs on first "up" click to nav item
			$("html, body").animate(
				{
					scrollTop: Math.floor($(targetID).offset().top - offset),
					start: function() {
						$(window).scrollTop(currentPosition);
					}
				},
				1
			);
			unsetBoldLink();
			setBoldLink($("a[href='" + targetID + "']"));
			if (targetID == "#AllMaterials") {
				// Exception case for Downloads page
				$("a.budget-download").focus();
			} else {
				if ($("article" + targetID).find("h2").length) {
					$("article" + targetID)
						.find("h2")
						.not(".no-focus")
						.focus();
				} else if ($("article" + targetID).find("h3").length) {
					$("article" + targetID)
						.find("h3")
						.not(".no-focus")
						.focus();
				} else if ($("article" + targetID).find("h4").length) {
					$("article" + targetID)
						.find("h4")
						.not(".no-focus")
						.focus();
				}
			}
		}, 301);
	}
	function getVisibleScrollContent() {
		if ($_scrollContent.length) {
			var $el = $_scrollContent,
				scrollTop = $(this).scrollTop(),
				scrollBot = scrollTop + $(this).height(),
				elTop = $el.offset().top,
				elBottom = elTop + $el.outerHeight();
			var $el2 = $(".sticky-wrapper"),
				menuHeight = $el2.height();
			var visibleTop = elTop < scrollTop ? scrollTop : elTop;
			var visibleBottom = elBottom > scrollBot ? scrollBot : elBottom;
			//console.log("dif: " + (visibleBottom - visibleTop - menuHeight < 150));
			var contentTooSmall = visibleBottom - visibleTop - menuHeight < 130;
			var windowTooSmall =
				menuHeight + $("#header").height() >= $(window).height();
			if (windowTooSmall) {
				$_stickyMenu.removeClass("stuck");
			}
			if (
				contentTooSmall &&
				$_stickyMenu.hasClass("stuck") &&
				!$("a.nav-link.first").hasClass("currentItem")
			) {
				$_stickyMenu.css({ opacity: 0, zIndex: -1 });
			} else {
				$_stickyMenu.css({ opacity: 1, zIndex: 1 });
			}
		}
	}
	function unsetBoldLink() {
		$("a.nav-link").css({
			backgroundColor: "#ffffff"
		});
		$("a.nav-link").removeClass("currentItem");
	}
	function setBoldLink(link) {
		link.css({
			backgroundColor: "#efefef"
		});
		link.addClass("currentItem");
	}
	function overrideSticky() {
		$(".side-menu-container").addClass("override-stuck");
	}
	function unsetOverrideSticky() {
		$(".side-menu-container").removeClass("override-stuck");
	}
	function doExternalClick(link) {
		thisLinksWindowName = "_blank";
		if (
			$(link)
				.closest("a")
				.attr("class")
				.indexOf("external ") != -1
		) {
			thisLinksWindowName = $(link)
				.closest("a")
				.attr("class")
				.split(" ")[
				$(link)
					.closest("a")
					.attr("class")
					.split(" ").length - 1
			];
		}
		$(link)
			.closest("a")
			.attr("target", thisLinksWindowName);
	}
});

